package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {
    private String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {
        String[] row = new String[board.length];
        for (int column = 0; column < board.length; column++) {
            row[column] = board[value][column];
        }
        return row;
    }

    public String[] getColumn(Integer value) {
        String[] column = new String[board.length];
        for (int row = 0; row < board.length; row++) {
            column[row] = board[row][value];
        }
        return column;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] row = getRow(rowIndex);
        for (int i = 0; i < row.length - 1; i++) {
            if (!row[i].equals(row[i + 1])) return false;
        }
        return true;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        String[] column = getColumn(columnIndex);
        for (int i = 0; i < column.length - 1; i++) {
            if (!column[i].equals(column[i + 1])) return false;
        }
        return true;
    }

    public String getWinner() {
        for (int i = 0; i < board.length; i++) {
            if (isRowHomogenous(i)) return getRow(i)[i];
            if (isColumnHomogeneous(i)) return getColumn(i)[i];
        }

        if (board[0][0].equals(board[1][1]) &&
            board[1][1].equals(board[2][2])) {
            return board[0][0];
        }

        if (board[0][2].equals(board[1][1]) &&
                board[1][1].equals(board[2][0])) {
            return board[0][2];
        }
        return null;
    }
}
