package rocks.zipcode.io.quiz3.generics;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.function.Function;

/**
 * @author leon on 09/12/2018.
 */
public class ArrayUtility<SomeType> {
    private final SomeType[] array;

    public ArrayUtility(SomeType[] array) {
        this.array = array;
    }

    public SomeType findOddOccurringValue() {
        HashMap<SomeType, Integer> map = new HashMap<SomeType, Integer>();
        for (SomeType someType : array) {
            if (!map.containsKey(someType)) {
                map.put(someType, 1);
            } else {
                map.put(someType, map.get(someType) + 1);
            }
        }

        for (SomeType something : map.keySet()) {
            if (map.get(something) > 1 && map.get(something) % 2 != 0) {
                return something;
            }
        }
        return null;
    }

    public SomeType findEvenOccurringValue() {
        HashMap<SomeType, Integer> map = new HashMap<SomeType, Integer>();
        for (SomeType someType : array) {
            if (!map.containsKey(someType)) {
                map.put(someType, 1);
            } else {
                map.put(someType, map.get(someType) + 1);
            }
        }

        for (SomeType something : map.keySet()) {
            if (map.get(something) > 1 && map.get(something) % 2 == 0) {
                return something;
            }
        }
        return null;
    }

    public Integer getNumberOfOccurrences(SomeType valueToEvaluate) {
        Integer count = 0;
        for (SomeType someType : array) {
            if (someType.equals(valueToEvaluate)) {
                count++;
            }
        }
        return count;
    }

    public SomeType[] filter(Function<SomeType, Boolean> predicate) {
        ArrayList<SomeType> someTypeArrayList = new ArrayList<>();
        for (SomeType someType : array) {
            if (predicate.apply(someType)) {
                someTypeArrayList.add(someType);
            }
        }
        return (SomeType[]) someTypeArrayList.toArray();
    }
}
